#!/bin/sh
#
# check_dependencies.sh  -  Check if all Perl modules are installed
#
#
# written 2006 by Joffrey Fitz fitzj@informatik.uni-tuebingen.de
#
# This script is part of the MSQT package written by
# Norman Warthmann and Joffrey Fitz
# http://msqt.weigelworld.org

# Perl Modules:
# Archive::Extract >=0.16
# CGI::Carp >=1.29
# CGI >=3.15
# DBI >=1.50
# DBD::Pg >=1.43
# File::Basename >=2.74
# File::Find >=1.10
# LWP::Simple >=1.41
# Switch >=2.10_01
# Sys::Hostname >=1.11
# URI >=1.35
# XML::Simple >=2.14

__dep_perl_mods="\
Archive::Extract \
CGI::Carp \
CGI \
DBI \
DBD::Pg \
File::Basename \
File::Find \
LWP::Simple \
Switch \
Sys::Hostname \
URI \
XML::Simple \
";


check_modules() {
	
	for i in $@
	do
		echo -n "Checking for ${i} ... "
		perl -M${i} -e "" 2> /dev/null
		if [ $? -eq 0 ] ; then echo "ok"
		else __internal_error=1; echo "no"; fi
	done
	
	# 	# check status
	echo
	if [ ${__internal_error} ]; then
		echo "!! Missing Requirements. Exiting."; exit 1
	else
		echo "All dependencies resolved."
	fi

	# reset error flag
	__internal_error=""
}


check_modules ${__dep_perl_mods}

#test_db
