#!/usr/bin/perl

# check_for_ecot_completness.pl
#
# Checks if all ecotypes provided in $argv[1] (ecotypes seperated by \n)
# are present int sequence file $argv[2].
# written 2005 by Joffrey Fitz
#
# Synopsis:
#   first create file distinct_chr1.list with get_distinct_etypes.sh. then
# find ./chromosome_1/ ./chromosome_2/ ./chromosome_3/ ./chromosome_4/ ./chromosome_5/ -type f -exec ./bug_fix/check_for_ecot_completness.pl ./distinct_ecotype.list target {} \;

use strict;

my $found=1;
my $ecotl;
my @ecot;
my @ecot2;
my $buf;
my $Ns;;

my $ecot_list = $ARGV[0];
my $target = $ARGV[1];
my $seq_file = $ARGV[2];

# read ecotype list
open(fh, $ecot_list) or die "$!";
while(<fh>) {
	chomp;
	@ecot=(@ecot, $_);
}
close(fh);
#print @ecot;
#exit

# get ecotypes from sequence file
open(fh, $seq_file) or die "$!";
while(<fh>) {
	push(@ecot2, $1) if m/^>(.*)$/;
}
close(fh);

if (scalar(@ecot) < scalar(@ecot2)) {
	print "$ARGV[1]: has more ecotypes than specified in $ARGV[0]\n";
	exit;
}
# get missing ecotypes
elsif(scalar(@ecot) > scalar(@ecot2)) {
	# count bases of target
	open fh, "$seq_file" or die "$!";
	my $filebuf;
	while(<fh>) {
		$filebuf.=$_;
	}
	close(fh);
	$filebuf =~ />target\n(.*)\n/;
	my $i = length($1);
	while($i--) {
		$Ns .= 'N';
	}
	for(my $i=0; $i<scalar(@ecot); $i++) {
		if( scalar(grep /^$ecot[$i]$/, @ecot2)==0 ) {
			print "$seq_file: $ecot[$i] is missing\n";
			$buf .= ">$ecot[$i]\n" . $Ns . "\n";
		}
	}
	print "---\n";
}

if(length($buf) > 0) {
	
	open(fh, ">>$seq_file") or die "$!";
	print fh $buf;
	close(fh);
}




